/*
 * CBinarySearchAlgo.h
 *
 *  Created on: Oct 1, 2011
 *      Author: data
 */

#ifndef CBINARYSEARCHALGO_H_
#define CBINARYSEARCHALGO_H_

#include <string>
#include <ios>
#include <iostream>
#include <fstream>
#include <algorithm>

class CBinarySearchAlgo {

public:
	CBinarySearchAlgo();
	virtual ~CBinarySearchAlgo();

	/**
	 *
	 * string_to_match is the string we are trying to match from within the strings in the file
	 *
	 * @note the strings in the file are assumed to be in sorted order - if this is not maintained, then there are no guarantees for the O(logn) time complexity of search
	 */
	std::pair<std::streampos, bool> find(std::ifstream& binary_file_stream,
			std::ifstream& binary_index_file_stream, std::streampos index_record_length, std::string const& string_to_match);


private:

	/**
	 *
	 */
	std::pair<std::streampos, bool> binary_search_recursively(std::ifstream& in_stream,
			std::ifstream& binary_index_file_stream,
			std::streampos index_record_length,
			std::string const& string_to_match,
			std::streampos begin_index,
			std::streampos end_index);

	/**
	 *
	 */
	std::string binary_search_string(std::ifstream& in_stream, std::ifstream& binary_index_file_stream, std::streampos pos_in_index);
};

#endif /* CBINARYSEARCHALGO_H_ */
