/*
 * UnitTestCHeap.cpp
 *
 *  Created on: Sep 8, 2010
 *      Author: data
 */

#include "UnitTestCHeap.h"
using namespace std;

UnitTestCHeap::UnitTestCHeap() {

}

UnitTestCHeap::~UnitTestCHeap() {

}

void UnitTestCHeap::print_heap (CHeap<SObject, SObjectCompare>& heap) {
	cout << "[";
	for ( size_t i = 0; i < heap.length(); ++i ) {
		cout << heap[i] << ", " ;
	}
	cout << "]" << endl;
}

int UnitTestCHeap::main_heap(int argc, char** argv) {

	cout << "Unit Test main_heap() using vector" << endl;

	CHeap<SObject, SObjectCompare> a_heap;
	srand(3992929);
	size_t n_obs = 10;
	for ( size_t i = 0; i < n_obs; ++i ) {
		double val = 10.0*(rand()/(double)RAND_MAX);
		SObject s = SObject(val);
		a_heap.push_back(s);
	}
	print_heap(a_heap);
	a_heap.build_heap();	// this creates a max heap
	print_heap(a_heap);
	a_heap.sort();			// this sorts the max heap where the max elements are copied into the back of the array in ascending order
	print_heap(a_heap);
	return 0;
}

ostream& operator << (ostream& stream, SObject& o) {
	stream << o._val_double ;
	return stream;
}
