/*
 * UnitTestCHeap.h
 *
 *  Created on: Sep 8, 2010
 *      Author: data
 */

#ifndef UNITTESTCHEAP_H_
#define UNITTESTCHEAP_H_

#include "CHeap.h"
#include <iostream>
#include <cstdlib>

struct SObject {
	double _val_double;

	SObject(double a_val = 0) : _val_double(a_val) {}
	// copy constructors and assignment operators are supplied by default

	bool operator<(SObject const & a_object) const {
		return _val_double < a_object._val_double;
	}

	friend std::ostream& operator << (std::ostream& stream, SObject& o);

};

struct SObjectCompare {
	/**
	 * This makes SObjectCompare a function object comparing SObjects
	 */
	bool operator () (SObject const& l_object, SObject const& r_object) const {
		return l_object._val_double < r_object._val_double;
	}
};

class UnitTestCHeap {
public:
	UnitTestCHeap();
	virtual ~UnitTestCHeap();

	void print_heap (CHeap<SObject, SObjectCompare>& heap);
	int main_heap(int argc, char** argv);
};

#endif /* UNITTESTCHEAP_H_ */
