/*
 * Trie.cpp
 *
 *  Created on: Jan 28, 2010
 *      Author: data
 */

//============================================================================
// Name        : TrieTest.cpp
// Author      : Pradipto Das
// Version     :
// Copyright   : Your copyright notice
// Description : Trie C style C++ - not a good programming practice
//============================================================================
#include "Trie.h"

using namespace std;

STrieNode* insert_char_into_trie(STrieNode** root, char c) {

	STrieNode* current_parent = *root;

    // now the fun begins.
    // node doesn't have any children.
    if ( !(current_parent->_first_child) ) {
        current_parent->_first_child = new STrieNode(c);
        current_parent->_first_child->_parent = current_parent;
        current_parent->_sibling = new list<STrieNode*>();
        current_parent->_sibling->push_back(current_parent->_first_child);
        current_parent = current_parent->_first_child;
    } else {

        // there is a sibling list for this node.
        // move to the appropriate sibling as the most current parent.
        list<STrieNode*>::iterator itr;
        for( itr = current_parent->_sibling->begin(); (itr != current_parent->_sibling->end()); itr++) {
        	if ((*itr)->_c == c ) break;
        }
        if ( itr == current_parent->_sibling->end() ) {
            // this is a new char for this sibling list.
        	STrieNode* new_node = new STrieNode(c);
        	new_node->_parent = current_parent;
        	current_parent->_sibling->push_back(new_node);
        	current_parent = new_node;
        } else {
            current_parent = *itr;
        }
    }


    return current_parent;
}

void insert_word_into_trie(STrieNode** root, string& word) {

    STrieNode* current_parent;

    if ( !(*root) ) {
        // root node. (should contain the '$' only)
        *root = new STrieNode('$');
        (*root)->_parent = 0;
        (*root)->_first_child = 0;
    }

    current_parent = *root;
    cout << current_parent << endl;

    // go over all the characters in the word.
    for ( size_t i = 0; i < word.length(); i++ ) {
        current_parent = insert_char_into_trie(&(current_parent), word[i]);

    }

}

void print_trie(STrieNode* root, string word) {
    //string current_word = "";
    if ( root->_first_child ) {
        list<STrieNode*>::iterator itr;
        for (itr = root->_sibling->begin(); itr != root->_sibling->end(); itr++) {
            print_trie(*itr, word+(*itr)->_c);
        }
    } else {
        cout << word << endl;
    }
    return;
}

bool has_word(STrieNode* root, string word) {
	STrieNode* current_parent = 0;
	if ( !root ) return false;
	if ( root && (root->_c == '$'))
		current_parent = root;

	bool found = true;
	list<STrieNode*> *siblings;
	list<STrieNode*>::iterator itr;
	for ( size_t i = 0; i < word.length(); i++ ) {
		siblings = current_parent->_sibling;
		if ( siblings ) {
			for ( itr = siblings->begin(); itr != siblings->end(); itr++ )
				cout << (*itr)->_c << " ";
			cout << endl;

			for ( itr = siblings->begin(); itr != siblings->end(); itr++ )
				if ( (*itr)->_c == word[i] ) {
					current_parent = (*itr);
					break;
				}

			if ( itr == siblings->end() ) { cout << "itr == siblings->end()" << endl; found &= false; break;}

		}

	}
	return found;
}


