/*
 * Trie.h
 *
 *  Created on: Jan 28, 2010
 *      Author: data
 */

#ifndef TRIE_H_
#define TRIE_H_
#include <string>
#include <set>
#include <list>
#include <iostream>
#include <algorithm>

struct STrieNode{
    char _c;
    STrieNode *_first_child, *_parent;
    std::list<STrieNode*> *_sibling;

    STrieNode(char c) {
        _c = c;
        _first_child = 0; _parent = 0; _sibling = 0;
    }
    bool operator() (STrieNode* that) {
        return _c < that->_c;
    }
};

STrieNode* insert_char_into_trie(STrieNode** root, char c);
void insert_word_into_trie(STrieNode** root, std::string& word);
void print_trie(STrieNode* root, std::string word="");
bool has_word(STrieNode* root, std::string word);

#endif /* TRIE_H_ */
